commit d5f72834a4817b180625a540b99f5c1934c2e0b8
Author: Richard Biener <rguenther@suse.de>
Date:   Mon Jun 12 10:17:26 2023

    middle-end/110200 - genmatch force-leaf and convert interaction
    
    The following fixes code GENERIC generation for (convert! ...)
    which currently generates
    
      if (TREE_TYPE (_o1[0]) != type)
        _r1 = fold_build1_loc (loc, NOP_EXPR, type, _o1[0]);
        if (EXPR_P (_r1))
          goto next_after_fail867;
      else
        _r1 = _o1[0];
    
    where obviously braces are missing.
    
            PR middle-end/110200
            * genmatch.cc (expr::gen_transform): Put braces around
            the if arm for the (convert ...) short-cut.
    
    (cherry picked from commit 820d1aec89c43dbbc70d3d0b888201878388454c)

diff --git a/gcc/genmatch.cc b/gcc/genmatch.cc
index 5b25fc8da86..80c64d88928 100644
--- a/gcc/genmatch.cc
+++ b/gcc/genmatch.cc
@@ -2548,7 +2548,8 @@ expr::gen_transform (FILE *f, int indent, const char *dest, bool gimple,
 	{
 	  fprintf_indent (f, indent, "if (TREE_TYPE (_o%d[0]) != %s)\n",
 			  depth, type);
-	  indent += 2;
+	  fprintf_indent (f, indent + 2, "{\n");
+	  indent += 4;
 	}
       if (opr->kind == id_base::CODE)
 	fprintf_indent (f, indent, "_r%d = fold_build%d_loc (loc, %s, %s",
@@ -2571,7 +2572,8 @@ expr::gen_transform (FILE *f, int indent, const char *dest, bool gimple,
 	}
       if (*opr == CONVERT_EXPR)
 	{
-	  indent -= 2;
+	  fprintf_indent (f, indent - 2, "}\n");
+	  indent -= 4;
 	  fprintf_indent (f, indent, "else\n");
 	  fprintf_indent (f, indent, "  _r%d = _o%d[0];\n", depth, depth);
 	}

